<?php
/*
 ##############################################################################
 #	Plugin for xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 # @version $Id: class.vt_billsafe.php 936 2010-05-12 08:57:50Z ak $
 # @copyright:   found in /lic/copyright.txt
 #
 ##############################################################################
 */

	defined('_VALID_CALL') or die('Direct Access is not allowed.');

	class vt_billsafe {
		public $external = true;
		public $subpayments = true;
		public $iframe = false;
		public $pay_frame = false;
		public $post_form = true;
		public $data = array();
		public $TARGET_URL;
		public $IFRAME_URL;
		public $TARGET_PARAMS = array();

		function debug($value, $text='') {
			return; // no debugging
			$f = fopen(_SRV_WEBROOT._SRV_WEB_PLUGINS.'vt_billsafe/classes/debug.txt', "a+");
			fprintf($f, "%s\n\n--------\n\n",$text."\n\n".var_export ($value, true));
			fclose($f);
		}

		function __construct() {
			global $xtLink;

            $this->allowed_subpayments = array('INV', 'RAT');


            if($_GET['layeredPaymentGateway'] && VT_BILLSAFE_STATUS_PAYMENT_LAYER == "true") {
				$url = $xtLink->_link(array('page'=>'checkout', 'paction'=>'pay_frame', 'conn'=>'SSL'));
				$this->IFRAME_URL = $url;

				if ($_GET['page_action'] == '')
					$this->external = false;
			}
		}

		function _link($arr) {
			if($arr['conn'] == 'SSL' && _SYSTEM_SSL == true)
				$tmp_link = rtrim(_SYSTEM_BASE_HTTPS, '/');
			else
				$tmp_link = rtrim(_SYSTEM_BASE_URL, '/');

			$tmp_link .= _SRV_WEB;
			$tmp_link .= 'index.php?page=' . $arr['page'] . '&page_action=' . $arr['paction'];

			return $tmp_link;
		}

		function _addLogEntry($log_data) {
			global $db;

			if (is_array($log_data['callback_data'])) $log_data['callback_data'] = serialize($log_data['callback_data']);

			if ($log_data['transaction_id']==null) $log_data['transaction_id']='';

			$db->AutoExecute(TABLE_CALLBACK_LOG, $log_data, 'INSERT');
			$last_id = $db->Insert_ID();

			return $last_id;
		}

		function pspRedirect($order_data = array()) {
			global $xtLink, $filter, $order, $db, $info;

			if($_GET['layeredPaymentGateway'] && VT_BILLSAFE_STATUS_PAYMENT_LAYER == "true") {
				$order_data['billing']['customers_company'] = $order->order_data['billing_company'];
				$order_data['billing']['customers_gender'] = $order->order_data['billing_gender'];
				$order_data['billing']['customers_firstname'] = $order->order_data['billing_firstname'];
				$order_data['billing']['customers_lastname'] = $order->order_data['billing_lastname'];
				$order_data['billing']['customers_street_address'] = $order->order_data['billing_street_address'];
				$order_data['billing']['customers_postcode'] = $order->order_data['billing_postcode'];
				$order_data['billing']['customers_city'] = $order->order_data['billing_city'];
				$order_data['billing']['customers_country_code'] = $order->order_data['billing_country_code'];
				$order_data['billing']['customers_dob'] = $order->order_customer['customers_dob'];
				$order_data['billing']['customers_phone'] = $order->order_data['billing_phone'];
				$order_data['orders_id'] = $order->oID;
			}
            // (product=“installment“
            $subpayment = $_SESSION['selected_payment_sub'];
			require_once _SRV_WEBROOT.'plugins/vt_billsafe/classes/class.SoapApi.php';
			$SoapApi = new SoapApi();

			$response = $SoapApi->prepareOrder($order_data, $order,$subpayment);

			if($response->ack == 'OK') {
				if($_GET['layeredPaymentGateway'] && VT_BILLSAFE_STATUS_PAYMENT_LAYER == "true")
					$link = _SYSTEM_BASE_URL._SRV_WEB.'/plugins/vt_billsafe/frame.php?token='.$response->token;
				else
					$link = $SoapApi->getGatewayUrl().'?token='.$response->token;

				$this->TARGET_URL = $link;

				return $this->TARGET_URL;	
			} elseif($response->ack == 'ERROR') {
				$log_data['module'] = 'vt_billsafe';
				$log_data['orders_id'] = (int)$order_data['orders_id'];
				$log_data['class'] = 'error';
				$log_data['error_msg'] = 'checkout error';
				$log_data['error_data'] = serialize($response);
				$this->_addLogEntry($log_data);

				$url = $this->_link(array('page'=>'checkout', 'paction'=>'payment'));
				$info->_addInfoSession(ERROR_PAYMENT);

				header( 'Location: ' . $url);
				exit (0);
			}
		}

		function pspSuccess() {
			global $xtLink;

			$tmp_link  = $this->_link(array('page'=>'checkout', 'paction'=>'success', 'conn'=>'SSL'));

			$_SESSION['success_order_id'] = $_SESSION['last_order_id'];

			unset($_SESSION['last_order_id']);
		    unset($_SESSION['selected_shipping']);
		    unset($_SESSION['selected_payment']);
		    unset($_SESSION['conditions_accepted']);

			if ($_SESSION['cart']) {
				$_SESSION['cart']->_resetCart();
			}

			$xtLink->_redirect($tmp_link);
			exit (0);
		}
	}
?>