<?php
/*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');
include_once(_SRV_WEBROOT._SRV_WEB_FRAMEWORK.'classes/class.multistore.php');

class ExtEditForm extends ExtFunctions {

	function ExtEditForm() {
		
	}
	
/* _getTabStoreLangPanel
 *
 * Creating Panel with tabs for each Store
 *
 * @param (object) ($langPanel) - panel to append to
 * @return object - created panel with tabs
 */
	function _getTabStoreLangPanel ($langPanel = null) {
		global $language;
		if (count($this->lang_data) == 0) return false;
        if ($langPanel == null) {
    		$langPanel = new PhpExt_TabPanel();
    		$langPanel->setActiveTab(0)
    		->setDeferredRender(false)
    		->setEnableTabScroll(true)
    		->setDefaults(new PhpExt_Config_ConfigObject(array("autoHeight"=>true,"bodyStyle"=>"padding: 5px; margin:0px","hideMode"=>'offsets')));;
        }
		
		$n = new multistore;
		$stores = $n->getStores();
		
		 foreach($stores as $store)
		 {
		 	
			$rightPanel = new PhpExt_Panel();
			$rightPanel->setTitle($store['text'])
			->setCollapseFirst(true)
			->setBodyStyle("padding: 5px;")
			->setLayout(new PhpExt_Layout_FormLayout());
			$rightPanel->addItem($this->_getTabLangPanel(null,$store['id']));
			$langPanel->addItem($rightPanel);
		 }
		return $langPanel;
	}
	
/* _getTabLangPanel
 *
 * Creating Panel with tabs for each language
 *
 * @param (object) ($langPanel) - panel to append to
 * @param (string) ($store_id) - store_id in case we have Store panel created
 * @return object - created panel with tabs
 */
	function _getTabLangPanel ($langPanel = null,$store_id='') {
		global $language;
		if (count($this->lang_data) == 0) return false;
        if ($langPanel == null) {
    		$langPanel = new PhpExt_TabPanel();
    		$langPanel->setActiveTab(0)
    		->setDeferredRender(false)
    		->setEnableTabScroll(true)
    		->setDefaults(new PhpExt_Config_ConfigObject(array("autoHeight"=>true,"bodyStyle"=>"padding: 5px; margin:10px","hideMode"=>'offsets')));;
        }
		foreach ($language->_getLanguageList() as $key => $val) {
			if($val['edit']=='1') $langPanel->addItem($this->_getLangPanel($val,$store_id));
		}
		return $langPanel;
	}
	
/* _getLangPanel
 *
 * Creating each Language Tab
 *
 * @param (object) ($_lang) - language data
 * @param (string) ($store_id) - store_id in case we have Store panel created
 * @return object - created panel with tabs
 */
	function _getLangPanel($_lang,$store_id='') {

		$val = $_lang;
		//$gridForm = $extObj;
		$rightPanel = new PhpExt_Panel();
		$rightPanel->setTitle($val['text'])
		->setIconCssClass($val['code'].'_icon')

		->setCollapseFirst(true)
		->setBodyStyle("padding: 5px;")
		->setLayout(new PhpExt_Layout_FormLayout());
		//$rightPanel->setLayout(new PhpExt_Layout_FormLayout());
        $len_meta_keywords = 75;
        $len_meta_title = 75;
        $len_meta_des = 150;

		foreach ($this->lang_data[$val['code']] as $header_data) {

		$continue= true;
		if ((strpos($header_data['name'],'_store'.$store_id)===false) &&($store_id!='') ) $continue = false;
		
		if ($continue)
		{

			$header_data2 = $header_data;
			
			if ((strpos($header_data['name'],'_store'.$store_id)!==false) && (defined(str_replace("_STORE".$store_id,"",$header_data['text']))))
				$header_data2['text'] = constant(str_replace("_STORE".$store_id,"",$header_data['text']));
			
			$fField = $this->_switchFormField($header_data2, $val);
			if ($this->url_data['currentType']=='category'){
               $this->url_data['edit_id'] = $this->url_data['currentId'];
           }
            $ffield_header_id = $this->code.'_'.$header_data['name'].$this->url_data['edit_id'];
            if (isset($this->url_data['store_id'])) {
            	$ffield_header_id .= "_" . $this->url_data['store_id'];
            }
            $fField->setId($ffield_header_id);

			if(_SYSTEM_METATAGS_WORDS_COUNTER == 'true'){
                if(strpos(strtolower($header_data['name']),'meta_')!==false){
                    $fField->attachListener('change', new PhpExt_Listener(
                      PhpExt_Javascript::functionDef(null,
                         "// Some JS code
                            var number = 0;
                            var len_meta_keywords  = ".$len_meta_keywords.";
                            var len_meta_title   = ".$len_meta_title.";
                            var len_meta_des = ".$len_meta_des.";
                            var a = Ext.getCmp('".$ffield_header_id."').getValue();
                            var number = 0;
                            var matches = a.match(/\b/g);
                            if(matches) {
                                number = matches.length/2;
                            }
                            var nospaces = a.replace(/ /g,'');

                            var coutertext = '".TEXT_WORDS_COUNT.": '+number + ' - ".TEXT_CHARACTER_COUNTER.": ' + a.length ;
                            var pos_des = \"".$ffield_header_id."\".indexOf('description');
                            var pos_title = \"".$ffield_header_id."\".indexOf('title');
                            var pos_keywords = \"".$ffield_header_id."\".indexOf('keywords');
                            var len  =  a.length ;
                            if(pos_keywords == -1 && pos_des == -1 && pos_title > 0){
                                if(len > len_meta_title)
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #f00');
                                else
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #0f3');
                            }

                            if(pos_keywords == -1 && pos_des > 0 && pos_title == -1){
                                if(len > len_meta_des)
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #f00');
                                else
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #0f3');
                            }

                            if(pos_keywords > 0 && pos_des == -1 && pos_title == -1){
                                if(len > len_meta_keywords)
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #f00');
                                else
                                    Ext.getCmp('wordcouter_".$ffield_header_id."').getEl().setStyle('border', '1px solid #0f3');
                            }

                            Ext.getCmp('wordcouter_".$ffield_header_id."').setValue(coutertext);
                        "
                      )));
                }
            }
            $rightPanel->addItem($fField);
		}
            if(_SYSTEM_METATAGS_WORDS_COUNTER == 'true'){
                if(strpos(strtolower($ffield_header_id),'meta_')!==false){
                    $a = PhpExt_Form_TextField::createTextField('wordcouter_'.$ffield_header_id, 'wordcouter_'.$ffield_header_id);
                    $a->setHideLabel('wordcouter_'.$ffield_header_id);
                    $a->setDisabled(true);

                    $pos_des = stripos($ffield_header_id, 'description');
                    $pos_title = stripos($ffield_header_id, 'title');
                    $pos_keywords = stripos($ffield_header_id, 'keywords');
                    if($pos_keywords!==false){
                        if(strlen($header_data['value']) > $len_meta_keywords)
                            $a->setCssClass('word_counter_fail');
                        else
                            $a->setCssClass('word_counter_success');
                    }
                    if($pos_des!==false){
                        if(strlen($header_data['value']) > $len_meta_des)
                            $a->setCssClass('word_counter_fail');
                        else
                            $a->setCssClass('word_counter_success');
                    }
                    if($pos_title!==false){
                        if(strlen($header_data['value']) > $len_meta_title)
                            $a->setCssClass('word_counter_fail');
                        else
                            $a->setCssClass('word_counter_success');
                    }
                    $a->setId('wordcouter_'.$ffield_header_id);
                    if(trim($header_data['value']) != ''){
                        $coutertext = TEXT_WORDS_COUNT.": ".str_word_count(trim($header_data['value'])). " - ".TEXT_CHARACTER_COUNTER.": " .strlen(trim($header_data['value'])) ;
                        $a->setValue($coutertext);
                    }else{
                        $a->setValue('');
                    }

                    $rightPanel->addItem($a);
                }
            }
		}

		return $rightPanel;

	}
	function _getEditPanel () {

		$defaultPanel = new PhpExt_Panel();
		$defaultPanel->setTitle(__define("TEXT_DEFAULT"))
		             ->setAutoHeight(true);
		$defaultPanel->setLayout(new PhpExt_Layout_FormLayout())->setBodyStyle("padding: 5px;");
		if (is_array($this->nonlang_data))
		foreach ($this->nonlang_data as $header_data) {
			$defaultPanel->addItem($this->_switchFormField($header_data));
		}

		return $defaultPanel;
	}

	function getAddOn($position) {
		$functions = $this->params['GridEdit']['functions'];

		if (is_array($functions)) {
			$fh = new FunctionHandler();
			$fh->setNoMasterPanel(true);

			foreach ($functions as $val) {

				$group = $val['grouping'];
				if ($group=='0') $group='MAIN';
				if ($group==$position) {
					$fh->setStack($val['value'],$val['type'],$val['grouping']);
				}
			}

			$fh->_getHandler ();
			$jsStack = $fh->_getJsStack ();
		}
		return $jsStack;
	}

	function _getPanelPosition ($position, $paneltext = '', $groupingPosition) {
		$grouping = $this->_getData('editGroupingNonLang');
        $header_data = $this->_getData('headerNonLangData');
        $addon = $this->getAddOn($position, $tabPanel);


        $countPositions = count($groupingPosition) + count($addon);
        if ($countPositions > 1 || $position == 'LANGUAGE' || $position == 'STORELANGUAGE') {

	        $tabPanel = new PhpExt_TabPanel();
            $tabPanel->setActiveTab(0)
             		 ->setDeferredRender(false)
             		 ->setEnableTabScroll(true)
            		 ->setDefaults(new PhpExt_Config_ConfigObject(array("autoHeight"=>true,"bodyStyle"=>"margin:20px 10px","hideMode"=>'offsets')));
        }

        if ($position == 'STORELANGUAGE'){
			
			$tabPanel = $this->_getTabStoreLangPanel($tabPanel);
		}
		elseif ($position != 'LANGUAGE') {
	        foreach ($groupingPosition as $tabPanelIndex) {
	            if ( $tabPanelIndex != 'languages') {
                $Panel = new PhpExt_Panel();

				$Panel->setTitle(__define("TEXT_".$tabPanelIndex));

			    $Panel->setAutoHeight(true);
			    $Panel->setLayout(new PhpExt_Layout_FormLayout())->setBodyStyle("padding: 5px;");

                if (is_array($grouping[$tabPanelIndex]))
                foreach ($grouping[$tabPanelIndex] as $headerKey) {

				    $Panel->addItem($this->_switchFormField($header_data[$headerKey]));
                }

                if ($countPositions > 1)
                $tabPanel->addItem($Panel);
                else
                $tabPanel = $Panel;
	            }
	        }

            if (is_array($addon[0]))
			foreach ($addon[0] as $nr => $addon_data) {
				$tabPanel->addItem($addon_data);
			}

        } else {
            // langpanel
            $tabPanel = $this->_getTabLangPanel($tabPanel);
        }

        return $tabPanel;
	}



	function _getPanelGroups($form) {

	    $grouping = $this->_getData('editGroupingNonLang');
	    $panelSettings = $this->getSetting('panelSettings');
	    
	    if(is_array($panelSettings) && count($panelSettings)!=0){
		    foreach ($panelSettings as $mainPanel) {
		    	$form->addItem($this->_getPanelPosition($mainPanel['position'], $mainPanel['text'], $mainPanel['groupingPosition']));
		    }
	    }
        return $form;
	}


	function displayEditFormJS ($id) {
		global $language;

		$this->getLayout();
        $settings = $this->getSetting('rowActionsFunctions');
        $menu_settings = $this->getSetting('menuActionsFunctions');
        
		$_sr = $this->_storeEdit($id);
		$store = $_sr['store'];
		$reader = $_sr['reader'];
		// Form Panel
		$form = new PhpExt_Form_FormPanel($this->code.$this->getSelectionItem()."-grideditform") ;
		$form = $this->_getLabelPos($form);

		$form->setLabelWidth($this->getSetting('FormLabelWidth'));
		$form->setReader($reader);

		$form->setBodyStyle("background-color:#efefef; color:#000; padding: 5px;");

		$top = new PhpExt_Toolbar_Toolbar();
		$top = $this->getActionMenu($top);
		$top = $this->getUserMenu($top, 'Toolbar', 'edit');
		
		if (($this->getActivate('image') || $this->getActivate('file') || is_array($settings))) {
    		//$top = new PhpExt_Toolbar_Toolbar();
            $top = $this->getDynamicMenu($top);
            $top = $this->getFileMenu($top);
            
		}
		
		$form->addItem($top);
		
		if ($this->getActivate('image')) {
			$form->addItem($this->getAllImagesPreviewPanel());
		}		
		$form = $this->_getPanelGroups($form);
		
		if((array_key_exists('_STORE_DEFAULT_TEMPLATE',$reader->_fields->Collection) == true) || (array_key_exists('_SYSTEM_TEMPLATE',$reader->_fields->Collection) == true)){
		
			// news iframe for Templates on Marketplace
			$lang_code = $language->environment_language;
			$news_page = new PhpExt_Panel();
			$news_page->setTitle(TEXT_XT_TEMPLATES)
			        ->setAutoScroll(false)
			        ->setAutoWidth(true)
					->setAutoHeight(true)
					->setCssStyle('border:none;')
			        ->setLayout(new PhpExt_Layout_FitLayout());
			
			$news_page->setHtml('<iframe height="500" width="100%" frameborder="0" src="http://addons.xt-commerce.com/index.php?page=admin_templates&language='.$lang_code.'"></iframe>');
			$form->addItem($news_page);
		}
		
		// buttons
		$button_panel = new PhpExt_Panel() ;
		$button_panel->setButtonAlign("center");

		if (is_array($settings)) {
		    reset($settings);
		        foreach($settings as $action => $fkt_content) {
		              $Btn = PhpExt_Button::createTextButton(__define('TEXT_'.$action),
		                  new PhpExt_Handler(PhpExt_Javascript::stm($fkt_content)));
		                  $Btn->setIconCssClass($action." x-btn-text ");
                     $button_panel->addButton($Btn);
            }
		}

		$form->addItem($button_panel);

		if($this->checkPermission('edit')) {
			$form->addButton($this->_SubmitButton(__define("BUTTON_SAVE"), __define("TEXT_SAVING"), '-grideditform', 'close'));
			$form->addButton($this->_SubmitButton(__define("BUTTON_UPDATE"), __define("TEXT_SAVING"), '-grideditform', 'update'));
		}
		if($this->checkPermission('cancel')) {
			$form->addButton($this->_CloseButton(__define("BUTTON_CANCEL")));
		}

		if($this->checkPermission('reset'))
		$form->addButton($this->_ResetButton(__define("BUTTON_RESET"), $id));

		$form->setRenderTo(PhpExt_Javascript::variable("Ext.get('".$this->code.$this->getSelectionItem()."-grideditform')"));

		// debug messages
		$this->getDebugMessages ();

		$js = 'var '.$this->getSelectionItem().' = "'.$id.'";' . PhpExt_Ext::onReady(
		$store->getJavascript(false, "store"),

		PhpExt_Javascript::stm(PhpExt_QuickTips::init()),
		PhpExt_Javascript::assign($this->code."bd","Ext.get('".$this->code.$this->getSelectionItem()."-grideditform')"),
		$form->getJavascript(false, $this->code."gridEditForm"),
		$this->add_multimenuactions(),
                (_SYSTEM_USE_WYSIWYG=='TinyMce') ? 'tinyMCE.init(tinyMCESettings); ' : ''
		);
        // UBo++   
        $add_js = $this->getSetting('rowActionsJavascript');
        $js .= $add_js."";
        //UBo--
		return '<script type="text/javascript" charset="utf-8">' . $js . '</script><div id="'.$this->code.$this->getSelectionItem().'-grideditform"></div>';

	}

	function _storeSingle($id) {
		$grid_data = array();
		if ($this->grid_data)
		foreach ($this->grid_data as $key => $data) {
			if ($id == $data[$this->getMasterKey()])
			$grid_data[] = $data;
		}
		//$this->singledata = array(array(1,'b','c'));
		$reader = $this->_reader('Array');
		// Store
		$store = new PhpExt_Data_Store();
		$store->setReader($reader);
		//              ->setData(PhpExt_Javascript::variable("singledata"));
		//		$store->setReader($reader);
		if (count($grid_data) > 0 )
		$store->setData($grid_data);
		return $store;
	}

	// Store
	function _storeEdit($id) {
		$store = new PhpExt_Data_Store();

		$reader = $this->_reader();

		$store->setProxy(new PhpExt_Data_HttpProxy($this->getSetting('readfull_url').'get_data=true'))
		->setReader($reader)
		->setBaseParams(array("limit"=> $this->getSetting('PageSize')));

		return array('store' => $store, 'reader' => $reader);
	}
	function _switchFormField ($line_data, $lang_data = array()) {

		$label = $line_data['name'];
		//		$name = __define($line_data['text']);
		$name = $line_data['text'];
		$value = true;


		switch ($line_data['type']) {
			case "textarea":
				$data = PhpExt_Form_TextArea::createTextArea($label, $name);
				if (isset($line_data['height'])) {
					$data->setHeight($line_data['height']);
				} else {
					$data->setHeight('150');
				}
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('70%');
				}

				break;
			case "admininfo":
				$data = PhpExt_Form_TextArea::createTextArea($label, $name);
				if (isset($line_data['height'])) {
					$data->setHeight($line_data['height']);
				} else {
					$data->setHeight('80');
				}
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('70%');
				}
				$data->setCssClass('form_info');

				break;
			case "htmleditor":

				if(_SYSTEM_USE_WYSIWYG=='SimpleHtmlEditor'){
					
                                    $data = PhpExt_Form_HtmlEditor::createHtmlEditor($label, $name);
                                    if (isset($line_data['required'])) {
                                        $line_data['required'] = '';
                                    }
                                    break;

				}elseif(_SYSTEM_USE_WYSIWYG=='TinyMce'){
					
 					$data = PhpExt_Form_TextArea::createTextArea($label, $name);
    				$data->setCssClass('TinyMce');
					break;

				}elseif(_SYSTEM_USE_WYSIWYG=='ckeditor') {

                    $data = PhpExt_Form_CKEditor::createCKEditor($label, $name);
                    if (isset($line_data['required'])) {
                        $line_data['required'] = '';
                    }
                    break;


                }else{

					$data = PhpExt_Form_TextArea::createTextArea($label, $name);
					if (isset($line_data['height'])) {
						$data->setHeight($line_data['height']);
					} else {
						$data->setHeight('150');
					}
					if (isset($line_data['width'])) {
						$data->setWidth($line_data['width']);
					} else {
						$data->setWidth('70%');
					}

					break;
				}

			case "image":
				$uniqueID = $name.'_'.time();

				// dummy field
				$data = PhpExt_Form_Hidden::createHidden($label, $name);

				if (!$line_data['value'])
				$value = false;
				break;
			case "file":
				$uniqueID = $name.'_'.time();
				$data = PhpExt_Form_TextField::createTextField($label, $name, $uniqueID);

				$panel = $this->_fileUploadPanel($data, $uniqueID, $line_data);

				if (!$line_data['value'])
				$value = false;
				break;
			case "logo":
				$uniqueID = $name.'_'.time();
				$data = PhpExt_Form_TextField::createTextField($label, $name, $uniqueID);

				$panel = $this->_logoUploadPanel($data, $uniqueID, $line_data);

				if (!$line_data['value'])
				$value = false;
				break;
			case "date":
				$data = PhpExt_Form_DateField::createDateField($label, $name);
				$data->setFormat('Y-m-d H:i:s'); 

				break;
			case "dropdown":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				$data = $this->_comboBox($label, $name, $line_data['url'],$line_data['width'],$line_data['listner']);
				break;
			case "dropdown_ms":
			case "dropdown_multi":
			case "dropdown_multiselect":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				// dropdown with checkbox
				$data = $this->_multiComboBox($label, $name, $line_data['url']);
				break;
			case "itemselect":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				if (!isset($line_data['valueUrl']) || empty($line_data['valueUrl'])) {
					$valueUrl = '';
				} else {
					$valueUrl = $line_data['valueUrl'];
				}
				$data = $this->_itemSelect($name, $label, $line_data['url'], $line_data['value'], $valueUrl);
				break;


			case "truefalse": //for admin configuration
			case "status":

				$data = PhpExt_Form_Checkbox::createCheckbox($label, $name);
				$data->setCssClass("checkBox");
				if ($line_data['value'] && $line_data['value'] != 'false')
				$data->setChecked(true);
				else
				$data->setChecked(false);

				// fix: set 'on' value to 1
				$data->setInputValue(1);

				$line_data['required'] = false; // combo not required
				break;
			case "master_key":
				//$data = PhpExt_Form_TextField::createTextField($label, $name);
				//$line_data['required'] = true; // default combo required
				//$data->setDisabled(true);
				//break;

			case "hidden":
				$line_data_value = (isset($line_data['value']) && strlen($line_data['value']) ? $line_data['value'] : "");
				$data = PhpExt_Form_Hidden::createHidden($label, $line_data_value);
				$line_data['required'] = false; // not required, user can not enter anything
				break;

			case "password":
				$data = PhpExt_Form_PasswordField::createPasswordField($label,$name);

				break;

			case "upload":
				$data = PhpExt_Form_UploadField::createUploadField($label,$name);
				break;

			default:
				$data = PhpExt_Form_TextField::createTextField($label, $name);
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('300');
				}
				if (isset($line_data['disabled'])) $data->setDisabled(true);

				break;
		}
		////////////////////////////////////////////////////////////////////////
		// field validation
		// readonly
		if ($line_data['readonly'] && !$this->getSetting('edit_masterkey')) {
			$data->setDisabled(true);
		}
		// minimum
		if ($line_data['min']) {
			$data->setMinLength($line_data['min']);
			$data->setMinLengthText(__define("ERROR_MIN"));
		}
		// maximum
		if ($line_data['max']) {
			$data->setMaxLength($line_data['max']);
			$data->setMaxLengthText(__define("ERROR_MAX"));
		}
		// required
		if ($line_data['required']) {
			$data->setAllowBlank(false);
			$data->setBlankText(__define("ERROR_BLANK"));
		}
		// field validation end
		////////////////////////////////////////////////////////////////////////

		// set field value
		if ($value && $line_data['value']!=='' && $line_data['value']!=='0000-00-00 00:00:00') {
			$data->setValue($line_data['value']);
		}
		if ($panel)
		$data = $panel;
		return $data;
	}
	
	
	
}
?>